#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <sys/stat.h>

#include "asim/rrr/service_ids.h"

#include "asim/provides/connected_application.h"

using namespace std;

// ===== service instantiation =====
AUDIOCORERRR_SERVER_CLASS AUDIOCORERRR_SERVER_CLASS::instance;

// constructor
AUDIOCORERRR_SERVER_CLASS::AUDIOCORERRR_SERVER_CLASS() :
  serverStub(new AUDIOCORERRR_SERVER_STUB_CLASS(this))
{
    // instantiate stub

    printf("ReceiveSide Created\n");
    outputFile = NULL;
    memory = NULL;
    fflush(stdout);
    count = 0;
}

// destructor
AUDIOCORERRR_SERVER_CLASS::~AUDIOCORERRR_SERVER_CLASS()
{
  printf("rlm:  AUDIOCORERRR_SERVER_CLASS::~AUDIOCORERRR_SERVER_CLASS()\n");
    Cleanup();
}

// init
void
AUDIOCORERRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)
{
  printf("rlm: AUDIOCORERRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)\n");
  parent = p;
}

// uninit
void
AUDIOCORERRR_SERVER_CLASS::Uninit()
{
  printf("rlm:  AUDIOCORERRR_SERVER_CLASS::Uninit()\n");
  Cleanup();
}

// cleanup
void
AUDIOCORERRR_SERVER_CLASS::Cleanup()
{
  printf("rlm: AUDIOCORERRR_SERVER_CLASS::Cleanup() \n\n");
  delete serverStub;
}


//
// RRR service methods
//

/* Not used by scratchpad
UINT32
AUDIOCORERRR_SERVER_CLASS::MemoryRequestLoad (UINT32 address)
{
  UINT32 returnVal;
  printf("rlm: AUDIOCORERRR_SERVER_CLASS::MemoryRequestLoad (UINT32 address)\n");
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }

 
  memory->Read(0,(UINT64) address, sizeof(UINT32), &returnVal); 
  return returnVal;
}

void
AUDIOCORERRR_SERVER_CLASS::MemoryRequestStore (UINT32 address, UINT32 data)
{
  printf("rlm: AUDIOCORERRR_SERVER_CLASS::MemoryRequestStore (UINT32 address, UINT32 data)\n");
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }

  memory->Write(0,(UINT64) address, sizeof(UINT32), &data); 
}
*/

void
AUDIOCORERRR_SERVER_CLASS::SendTerminate(UINT32 flag)
{
  printf("lsp: Received Process Termination\n");
  CONNECTED_APPLICATION_CLASS::EndSimulation(); 
}

void

AUDIOCORERRR_SERVER_CLASS::SendProcessedStream(UINT16 control, UINT16 data)
{

  //  printf("rlm: SendProcessedStream called,\n");
  AudioProcessorControl audioProcessorControl = (AudioProcessorControl) control;
  switch(control) {
    case EndOfFile:
      if(outputFile != NULL) {
	printf("rlm: FILE is NULL\n");
        fflush(outputFile);
        fclose(outputFile);
        outputFile = NULL;
      } else {
	printf("rlm: Opening file for output.\n");
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
        fflush(outputFile);
        fclose(outputFile);
      }

      // Long term this should be in the data portion.  But until I have code running, keep it here.
      //      count++;
      //if (count == 2)
        CONNECTED_APPLICATION_CLASS::EndSimulation(); 
    break;

    case Data:
      if(outputFile == NULL) {
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
      }

      CONNECTED_APPLICATION_CLASS::UpdateSemaphore(); 
      //      printf("rlm: writing data to out_hw.pcm\n");
      fwrite(&data, 2,1 , outputFile);
    break;
  }
}
